  
//+-------------------------------------------------------------------------------+ 
//|                                     fib bands.mq4                             | 
//+-------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------+
//|                  Copyright  2011,http://www.forex-tsd.com                    |
//|       You are NOT ALLOWED to distribute this Indicator in any public forum    |
//|           Property of  http://www.forex-tsd.com ELITE section ONLY            |
//|                       WARNING, Use this Indicator at your risk                |
//|                                                                               |
//+-------------------------------------------------------------------------------+

#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Plum
#property indicator_color2  LightSkyBlue

//
//
//
//
//

extern int    Band_Period     = 50;
extern string note            = "Price type 0=High/Low & 1=Open/Close";
extern int    price_type      = 0; 
extern color  FiboLinesColors = DarkSlateGray;
extern double Fibo_Level_1    = 0.236;
extern double Fibo_Level_2    = 0.382;
extern double Fibo_Level_3    = 0.500;
extern double Fibo_Level_4    = 0.618;
extern double Fibo_Level_5    = 0.764;
extern double Fibo_Level_6    = 0.886;
extern double Fibo_Level_0    = 0.000;
extern double Fibo_Level_7    = 1.000;

//
//
//
//
//

double Buffer1[];
double Buffer2[];

//
//
//
//
//

int init() 
{

        SetIndexBuffer(0,Buffer1); 
        SetIndexBuffer(1,Buffer2); 

        IndicatorDigits(Digits+2);

        IndicatorShortName("Automatic Fibonacci");

return(0);
}

//
//
//
//
//

int deinit() { ObjectDelete("AutoFibo"); }

//
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {

       Buffer1[i] = getPeriodHigh(Band_Period,i);
       Buffer2[i] = getPeriodLow(Band_Period, i);
       
       ObjectCreate("AutoFibo",OBJ_FIBO,0,Time[i],High[i],Time[i],Low[i]);
       ObjectSet("AutoFibo",OBJPROP_TIME1,Time[Band_Period]);
       ObjectSet("AutoFibo",OBJPROP_TIME2,Time[i]);
       ObjectSet("AutoFibo",OBJPROP_LEVELCOLOR,FiboLinesColors);
       ObjectSet("AutoFibo",OBJPROP_LEVELSTYLE,STYLE_DASHDOT);
       ObjectSet("AutoFibo",OBJPROP_FIBOLEVELS,8);
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+0,Fibo_Level_0);   ObjectSetFiboDescription("AutoFibo",0,DoubleToStr(Fibo_Level_0,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+1,Fibo_Level_1);   ObjectSetFiboDescription("AutoFibo",1,DoubleToStr(Fibo_Level_1,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+2,Fibo_Level_2);   ObjectSetFiboDescription("AutoFibo",2,DoubleToStr(Fibo_Level_2,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+3,Fibo_Level_3);   ObjectSetFiboDescription("AutoFibo",3,DoubleToStr(Fibo_Level_3,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+4,Fibo_Level_4);   ObjectSetFiboDescription("AutoFibo",4,DoubleToStr(Fibo_Level_4,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+5,Fibo_Level_5);   ObjectSetFiboDescription("AutoFibo",5,DoubleToStr(Fibo_Level_5,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+6,Fibo_Level_6);   ObjectSetFiboDescription("AutoFibo",6,DoubleToStr(Fibo_Level_6,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+7,Fibo_Level_7);   ObjectSetFiboDescription("AutoFibo",7,DoubleToStr(Fibo_Level_7,4));
       
   if (Open[Band_Period] < Open[i]) 
   { // Up
   
       ObjectSet("AutoFibo",OBJPROP_PRICE1,getPeriodHigh(Band_Period,i));
       ObjectSet("AutoFibo",OBJPROP_PRICE2,getPeriodLow(Band_Period, i));
       ObjectSet("AutoFibo",OBJPROP_LEVELCOLOR,FiboLinesColors);
       ObjectSet("AutoFibo",OBJPROP_LEVELSTYLE,STYLE_DASHDOT);
       ObjectSet("AutoFibo",OBJPROP_FIBOLEVELS,8);
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+0,Fibo_Level_0);   ObjectSetFiboDescription("AutoFibo",0,DoubleToStr(Fibo_Level_0,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+1,Fibo_Level_1);   ObjectSetFiboDescription("AutoFibo",1,DoubleToStr(Fibo_Level_1,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+2,Fibo_Level_2);   ObjectSetFiboDescription("AutoFibo",2,DoubleToStr(Fibo_Level_2,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+3,Fibo_Level_3);   ObjectSetFiboDescription("AutoFibo",3,DoubleToStr(Fibo_Level_3,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+4,Fibo_Level_4);   ObjectSetFiboDescription("AutoFibo",4,DoubleToStr(Fibo_Level_4,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+5,Fibo_Level_5);   ObjectSetFiboDescription("AutoFibo",5,DoubleToStr(Fibo_Level_5,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+6,Fibo_Level_6);   ObjectSetFiboDescription("AutoFibo",6,DoubleToStr(Fibo_Level_6,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+7,Fibo_Level_7);   ObjectSetFiboDescription("AutoFibo",7,DoubleToStr(Fibo_Level_7,4));
   } 
   else 
   {
       ObjectSet("AutoFibo",OBJPROP_PRICE1,getPeriodLow(Band_Period,i ));
       ObjectSet("AutoFibo",OBJPROP_PRICE2,getPeriodHigh(Band_Period,i));
       ObjectSet("AutoFibo",OBJPROP_LEVELCOLOR,FiboLinesColors);
       ObjectSet("AutoFibo",OBJPROP_LEVELSTYLE,STYLE_DASHDOT);
       ObjectSet("AutoFibo",OBJPROP_FIBOLEVELS,8);
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+0,Fibo_Level_0);   ObjectSetFiboDescription("AutoFibo",0,DoubleToStr(Fibo_Level_0,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+1,Fibo_Level_1);   ObjectSetFiboDescription("AutoFibo",1,DoubleToStr(Fibo_Level_1,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+2,Fibo_Level_2);   ObjectSetFiboDescription("AutoFibo",2,DoubleToStr(Fibo_Level_2,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+3,Fibo_Level_3);   ObjectSetFiboDescription("AutoFibo",3,DoubleToStr(Fibo_Level_3,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+4,Fibo_Level_4);   ObjectSetFiboDescription("AutoFibo",4,DoubleToStr(Fibo_Level_4,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+5,Fibo_Level_5);   ObjectSetFiboDescription("AutoFibo",5,DoubleToStr(Fibo_Level_5,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+6,Fibo_Level_6);   ObjectSetFiboDescription("AutoFibo",6,DoubleToStr(Fibo_Level_6,4));
       ObjectSet("AutoFibo",OBJPROP_FIRSTLEVEL+7,Fibo_Level_7);   ObjectSetFiboDescription("AutoFibo",7,DoubleToStr(Fibo_Level_7,4));
   }

}
return(0);
}

//
//
//
//
//

double getPeriodHigh(int period, int pos)
{
       int i;
       double buffer = 0;
       
       for(i=pos;i<=pos+period;i++) 
       {
         if(price_type == 0) 
         {
         if(High[i] >  buffer) { buffer = High[i]; }
         }
         else 
         {
         if(Open[i] > Close[i]) 
         { // Down
         if(Open[i] >  buffer) { buffer = Open[i]; }
         } 
         else 
         {
         if(Close[i] > buffer) { buffer = Close[i]; }
       }
    }
}
return (buffer);
}

//
//
//
//
//

double getPeriodLow(int period, int pos) 
{
       int i;
       double buffer = 100000;
        
       for (i=pos;i<=pos+period;i++) 
       {
         if (price_type == 0) 
         {
         if (Low[i] <   buffer) { buffer = Low[i]; }
         } 
         else 
         {
         if (Open[i] > Close[i]) 
         { // Down
         if (Close[i] < buffer) { buffer = Close[i]; }
         } 
         else 
         {
         if (Open[i] <  buffer) { buffer = Open[i]; }
       }
   }
}
return (buffer);
}
  
//+------------------------------------------------------------------+